!CCXでオンサイト木橋(孔無し一部非一体化モデル)の1/4解析
! つまり、接触 + 幾何学非線形 解析で局部座屈させる。
! アンカープレートのみにプレストレス力をかける。
implicit none
!#---入力
real    :: b1=840.d-3/2       ! m   :木材全体の幅(x)/2
real    :: h1=120.d-3         ! m   :木材の高さ(y)
real    :: h2=260.d-3         ! m   :上下木材の間隔(y)
real    :: b2=9.0d-3          ! m   :鋼板の厚さ(x)
real    :: ell=7300.d-3/2     ! m   :長さ(z)/2
real    :: koteiy=150.d-3     ! m   :端から境界条件までの距離(z)
real    :: sakaiz=365.d-3     ! m   :軸方向中央からの境界までの距離(z)
real    :: py=500.d-3/4       ! MN  :荷重/4
real    :: px=70.d-3          ! MN  :プレストレス力
integer :: nstep=100          !     :出力ステップ数
real    :: anka=100.d-3       ! m   :アンカープレートの一辺の長さ
real    :: hazip=350.d-3      ! m   :端からPC鋼棒までの距離(z)
real    :: ellp=700.d-3       ! m   :PC鋼棒の間隔
integer :: np=10              !     :PC鋼棒の本数(上下合わせて)
integer :: nx1=28             !     :木材の幅員方向(x)分割数
integer :: nx2=4              !     :鋼板の厚さ方向(x)分割数
integer :: ny1=8              !     :上下木材の高さ方向(y)分割数
integer :: ny2=16             !     :上下木材間隔の高さ方向(y)分割数
integer :: nz1=128            !     :橋軸方向1(z)分割数
integer :: nz2=32             !     :橋軸方向2(z)分割数
real    :: ezz=7.694d3        ! MPa :木材のz軸方向ヤング率
real    :: exx=7.694d3/25.0d0 ! MPa :木材のx軸方向ヤング率
real    :: eyy=7.694d3/25.0d0 ! MPa :木材のy軸方向ヤング率
real    :: poizx=0.4d0        !     :木材のポアソン比
real    :: ekou=206.0d3       ! MPa :鋼材のヤング率
real    :: poikou=0.3         !     :鋼材のポアソン比
!---
real    :: gxy,gxz,gyz,poizy,poixy,poixz,poiyx,poiyz
real    :: x(1000000),y(1000000),z(1000000),e66(6,6),b(3,3)
integer :: mesh1(300000,8),mesh2(300000,8)
real    :: dx1,dx2,dy1,dy2,dz1,dz2,sakaix,ts
integer :: i,j,k,l,nset,nset1,nset2,nyou,nyou1,nyou2,nyou3,nyou4,nsaika1,nsaika2,npre
!sakaix=b2+b1*2.d0/7! m :鋼板から境界までの距離(x)
!---せん断弾性係数
gxy=ezz/15
gxz=gxy
gyz=gxy
!---ポアソン比
poizy=poizx
poixy=poizx*exx/ezz
poixz=poixy
poiyx=poixy
poiyz=poixy
!---要素長さ
dx1=b1/nx1
dx2=b2/nx2
dy1=h1/ny1
dy2=h2/ny2
dz1=(ell-sakaiz+anka/2)/nz1
dz2=(sakaiz-anka/2)/nz2
!---鋼板の節点座標
nset=0
do k=0,nz1!---一体化部
   !---鋼板上部
   do j=0,ny1
      do i=0,nx2
         nset=nset+1
         x(nset)=dx2*i
         y(nset)=dy1*j
         z(nset)=dz1*k
      enddo
   enddo
   !---鋼板中部
   do j=1,ny2
      do i=0,nx2
         nset=nset+1
         x(nset)=dx2*i
         y(nset)=h1+dy2*j
         z(nset)=dz1*k
      enddo
   enddo
   !---鋼板下部
   do j=1,ny1
      do i=0,nx2
         nset=nset+1
         x(nset)=dx2*i
         y(nset)=h1+h2+dy1*j
         z(nset)=dz1*k
      enddo
   enddo
enddo
do k=1,nz2!---非一体化部
   !---鋼板上部
   do j=0,ny1
      do i=0,nx2
         nset=nset+1
         x(nset)=dx2*i
         y(nset)=dy1*j
         z(nset)=ell-sakaiz+anka/2+dz2*k
      enddo
   enddo
   !---鋼板中部
   do j=1,ny2
      do i=0,nx2
         nset=nset+1
         x(nset)=dx2*i
         y(nset)=h1+dy2*j
         z(nset)=ell-sakaiz+anka/2+dz2*k
      enddo
   enddo
   !---鋼板下部
   do j=1,ny1
      do i=0,nx2
         nset=nset+1
         x(nset)=dx2*i
         y(nset)=h1+h2+dy1*j
         z(nset)=ell-sakaiz+anka/2+dz2*k
      enddo
   enddo
enddo
nset1=nset
!---木材の節点座標
do k=0,nz1!---一体化部
   !---木材上部
   do j=0,ny1
      do i=1,nx1
         nset=nset+1
         x(nset)=b2+dx1*i
         y(nset)=dy1*j
         z(nset)=dz1*k
      enddo
   enddo
   !---木材下部
   do j=0,ny1
      do i=1,nx1
         nset=nset+1
         x(nset)=b2+dx1*i
         y(nset)=h1+h2+dy1*j
         z(nset)=dz1*k
      enddo
   enddo
enddo
do k=1,nz2!---非一体化部
   !---木材上部
   do j=0,ny1
      do i=0,nx1
         nset=nset+1
         x(nset)=b2+dx1*i
         y(nset)=dy1*j
         z(nset)=ell-sakaiz+anka/2+dz2*k
      enddo
   enddo
   !---木材下部
   do j=0,ny1
      do i=0,nx1
         nset=nset+1
         x(nset)=b2+dx1*i
         y(nset)=h1+h2+dy1*j
         z(nset)=ell-sakaiz+anka/2+dz2*k
      enddo
   enddo
enddo
nset2=nset-nset1
!---鋼板の要素を構成する節点
nyou=0
do k=0,nz1-1!---一体化部
   do j=0,(ny1*2+ny2)-1
      do i=1,nx2
         nyou=nyou+1
         mesh1(nyou,1)=(nx2+1)*(ny1*2+ny2+1)*k+(nx2+1)*j+i
         mesh1(nyou,2)=mesh1(nyou,1)+(nx2+1)
         mesh1(nyou,3)=mesh1(nyou,2)+(nx2+1)*(ny1*2+ny2+1)
         mesh1(nyou,4)=mesh1(nyou,1)+(nx2+1)*(ny1*2+ny2+1)
         mesh1(nyou,5)=mesh1(nyou,1)+1
         mesh1(nyou,6)=mesh1(nyou,5)+(nx2+1)
         mesh1(nyou,7)=mesh1(nyou,6)+(nx2+1)*(ny1*2+ny2+1)
         mesh1(nyou,8)=mesh1(nyou,5)+(nx2+1)*(ny1*2+ny2+1)
      enddo
   enddo
enddo
nyou1=nyou
do k=0,nz2-1!---非一体化部
   do j=0,(ny1*2+ny2)-1
      do i=1,nx2
         nyou=nyou+1
         mesh1(nyou,1)=(nx2+1)*(ny1*2+ny2+1)*(nz1+k)+(nx2+1)*j+i
         mesh1(nyou,2)=mesh1(nyou,1)+(nx2+1)
         mesh1(nyou,3)=mesh1(nyou,2)+(nx2+1)*(ny1*2+ny2+1)
         mesh1(nyou,4)=mesh1(nyou,1)+(nx2+1)*(ny1*2+ny2+1)
         mesh1(nyou,5)=mesh1(nyou,1)+1
         mesh1(nyou,6)=mesh1(nyou,5)+(nx2+1)
         mesh1(nyou,7)=mesh1(nyou,6)+(nx2+1)*(ny1*2+ny2+1)
         mesh1(nyou,8)=mesh1(nyou,5)+(nx2+1)*(ny1*2+ny2+1)
      enddo
   enddo
enddo
nyou2=nyou-nyou1
!---木材の要素を構成する節点
nyou=0
do k=0,nz1-1!---一体化部
   !---木材上部
   do j=0,ny1-1
         !---鋼板と節点を共有している要素
         nyou=nyou+1
         mesh2(nyou,1)=((nx2+1)*(ny1*2+ny2+1))*k+(nx2+1)*(j+1)
         mesh2(nyou,2)=mesh2(nyou,1)+nx2+1
         mesh2(nyou,3)=mesh2(nyou,2)+(nx2+1)*(ny1*2+ny2+1)
         mesh2(nyou,4)=mesh2(nyou,1)+(nx2+1)*(ny1*2+ny2+1)
         mesh2(nyou,5)=nset1+(nx1*(ny1+1)*2)*k+nx1*j+1
         mesh2(nyou,6)=mesh2(nyou,5)+nx1
         mesh2(nyou,7)=mesh2(nyou,6)+nx1*(ny1+1)*2
         mesh2(nyou,8)=mesh2(nyou,5)+nx1*(ny1+1)*2
      do i=1,nx1-1
         !---木材だけの節点から成る要素
         nyou=nyou+1
         mesh2(nyou,1)=nset1+(nx1*(ny1+1)*2)*k+nx1*j+i
         mesh2(nyou,2)=mesh2(nyou,1)+nx1
         mesh2(nyou,3)=mesh2(nyou,2)+nx1*(ny1+1)*2
         mesh2(nyou,4)=mesh2(nyou,1)+nx1*(ny1+1)*2
         mesh2(nyou,5)=mesh2(nyou,1)+1
         mesh2(nyou,6)=mesh2(nyou,5)+nx1
         mesh2(nyou,7)=mesh2(nyou,6)+nx1*(ny1+1)*2
         mesh2(nyou,8)=mesh2(nyou,5)+nx1*(ny1+1)*2
      enddo
   enddo
   !---木材下部
   do j=0,ny1-1
         !---鋼板と節点を共有している要素
         nyou=nyou+1
         mesh2(nyou,1)=(nx2+1)*(ny1+ny2+1)+((nx2+1)*(ny1*2+ny2+1))*k+(nx2+1)*j
         mesh2(nyou,2)=mesh2(nyou,1)+nx2+1
         mesh2(nyou,3)=mesh2(nyou,2)+(nx2+1)*(ny1*2+ny2+1)
         mesh2(nyou,4)=mesh2(nyou,1)+(nx2+1)*(ny1*2+ny2+1)
         mesh2(nyou,5)=nset1+(nx1*(ny1+1))+(nx1*(ny1+1)*2)*k+nx1*j+1
         mesh2(nyou,6)=mesh2(nyou,5)+nx1
         mesh2(nyou,7)=mesh2(nyou,6)+nx1*(ny1+1)*2
         mesh2(nyou,8)=mesh2(nyou,5)+nx1*(ny1+1)*2
      do i=1,nx1-1
         !---木材だけの節点から成る要素
         nyou=nyou+1
         mesh2(nyou,1)=nset1+(nx1*(ny1+1))+(nx1*(ny1+1)*2)*k+nx1*j+i
         mesh2(nyou,2)=mesh2(nyou,1)+nx1
         mesh2(nyou,3)=mesh2(nyou,2)+nx1*(ny1+1)*2
         mesh2(nyou,4)=mesh2(nyou,1)+nx1*(ny1+1)*2
         mesh2(nyou,5)=mesh2(nyou,1)+1
         mesh2(nyou,6)=mesh2(nyou,5)+nx1
         mesh2(nyou,7)=mesh2(nyou,6)+nx1*(ny1+1)*2
         mesh2(nyou,8)=mesh2(nyou,5)+nx1*(ny1+1)*2
      enddo
   enddo
enddo
nyou3=nyou
   !---一体化部と非一体化部の境目
   do j=0,ny1-1!---木材上部
      !---鋼板と節点を共有している要素
      nyou=nyou+1
      mesh2(nyou,1)=((nx2+1)*(ny1*2+ny2+1))*nz1+(nx2+1)*(j+1)
      mesh2(nyou,2)=mesh2(nyou,1)+(nx2+1)
      mesh2(nyou,3)=nset1+(nx1*(ny1+1)*2)*(nz1+1)+(nx1+1)*(j+1)+1
      mesh2(nyou,4)=nset1+(nx1*(ny1+1)*2)*(nz1+1)+(nx1+1)*j+1
      mesh2(nyou,5)=nset1+(nx1*(ny1+1)*2)*nz1+nx1*j+1
      mesh2(nyou,6)=mesh2(nyou,5)+nx1
      mesh2(nyou,7)=mesh2(nyou,6)+nx1*(ny1+1)*2+(j+2)
      mesh2(nyou,8)=mesh2(nyou,5)+nx1*(ny1+1)*2+(j+1)
      do i=1,nx1-1!---木材だけの節点から成る要素
         nyou=nyou+1
         mesh2(nyou,1)=nset1+(nx1*(ny1+1)*2)*nz1+nx1*j+i
         mesh2(nyou,2)=mesh2(nyou,1)+nx1
         mesh2(nyou,3)=mesh2(nyou,2)+nx1*(ny1+1)*2+(j+2)
         mesh2(nyou,4)=mesh2(nyou,1)+nx1*(ny1+1)*2+(j+1)
         mesh2(nyou,5)=mesh2(nyou,1)+1
         mesh2(nyou,6)=mesh2(nyou,5)+nx1
         mesh2(nyou,7)=mesh2(nyou,6)+nx1*(ny1+1)*2+(j+2)
         mesh2(nyou,8)=mesh2(nyou,5)+nx1*(ny1+1)*2+(j+1)
      enddo
   enddo
   do j=0,ny1-1!---木材下部
      !---鋼板と節点を共有している要素
      nyou=nyou+1
      mesh2(nyou,1)=((nx2+1)*(ny1*2+ny2+1))*nz1+(nx2+1)*(ny1+ny2+j+1)
      mesh2(nyou,2)=mesh2(nyou,1)+(nx2+1)
      mesh2(nyou,3)=nset1+(nx1*(ny1+1)*2)*(nz1+1)+(nx1+1)*(ny1+1+j+1)+1
      mesh2(nyou,4)=nset1+(nx1*(ny1+1)*2)*(nz1+1)+(nx1+1)*(ny1+1+j)+1
      mesh2(nyou,5)=nset1+(nx1*(ny1+1)*2)*nz1+nx1*(ny1+j+1)+1
      mesh2(nyou,6)=mesh2(nyou,5)+nx1
      mesh2(nyou,7)=mesh2(nyou,6)+nx1*(ny1+1)*2+(ny1+1+j+2)
      mesh2(nyou,8)=mesh2(nyou,5)+nx1*(ny1+1)*2+(ny1+1+j+1)
      do i=1,nx1-1!---木材だけの節点から成る要素
         nyou=nyou+1
         mesh2(nyou,1)=nset1+(nx1*(ny1+1)*2)*nz1+nx1*(ny1+1+j)+i
         mesh2(nyou,2)=mesh2(nyou,1)+nx1
         mesh2(nyou,3)=mesh2(nyou,2)+nx1*(ny1+1)*2+(ny1+1+j+2)
         mesh2(nyou,4)=mesh2(nyou,1)+nx1*(ny1+1)*2+(ny1+1+j+1)
         mesh2(nyou,5)=mesh2(nyou,1)+1
         mesh2(nyou,6)=mesh2(nyou,5)+nx1
         mesh2(nyou,7)=mesh2(nyou,6)+nx1*(ny1+1)*2+(ny1+1+j+2)
         mesh2(nyou,8)=mesh2(nyou,5)+nx1*(ny1+1)*2+(ny1+1+j+1)
      enddo
   enddo
do k=0,nz2-2!---非一体化部
   !---木材上部
   do j=0,ny1-1
      do i=1,nx1
         nyou=nyou+1
         mesh2(nyou,1)=nset1+(nx1*(ny1+1)*2)*(nz1+1)+((nx1+1)*(ny1+1)*2)*k+(nx1+1)*j+i
         mesh2(nyou,2)=mesh2(nyou,1)+(nx1+1)
         mesh2(nyou,3)=mesh2(nyou,2)+(nx1+1)*(ny1+1)*2
         mesh2(nyou,4)=mesh2(nyou,1)+(nx1+1)*(ny1+1)*2
         mesh2(nyou,5)=mesh2(nyou,1)+1
         mesh2(nyou,6)=mesh2(nyou,5)+(nx1+1)
         mesh2(nyou,7)=mesh2(nyou,6)+(nx1+1)*(ny1+1)*2
         mesh2(nyou,8)=mesh2(nyou,5)+(nx1+1)*(ny1+1)*2
      enddo
   enddo
   !---木材下部
   do j=0,ny1-1
      do i=1,nx1
         nyou=nyou+1
         mesh2(nyou,1)=nset1+(nx1*(ny1+1)*2)*(nz1+1)+((nx1+1)*(ny1+1)*2)*k+(nx1+1)*(ny1+1+j)+i
         mesh2(nyou,2)=mesh2(nyou,1)+(nx1+1)
         mesh2(nyou,3)=mesh2(nyou,2)+(nx1+1)*(ny1+1)*2
         mesh2(nyou,4)=mesh2(nyou,1)+(nx1+1)*(ny1+1)*2
         mesh2(nyou,5)=mesh2(nyou,1)+1
         mesh2(nyou,6)=mesh2(nyou,5)+(nx1+1)
         mesh2(nyou,7)=mesh2(nyou,6)+(nx1+1)*(ny1+1)*2
         mesh2(nyou,8)=mesh2(nyou,5)+(nx1+1)*(ny1+1)*2
      enddo
   enddo
enddo
nyou4=nyou-nyou3
!---節点座標の出力
print'("*NODE, NSET=Nall")'
do i=1,nset
   print'(i6,a,f9.6,a,f9.6,a,f9.6)',&
   &i,',',x(i),',',y(i),',',z(i)
enddo
!---鋼板の要素の出力
print'("*ELEMENT, TYPE=C3D8, ELSET=Ekou")'
do i=1,nyou1+nyou2
   print'(i6,a,i6,a,i6,a,i6,a,i6,a,i6,a,i6,a,i6,a,i6)',&
   &i,',',&
   &mesh1(i,1),',',&
   &mesh1(i,2),',',&
   &mesh1(i,3),',',&
   &mesh1(i,4),',',&
   &mesh1(i,5),',',&
   &mesh1(i,6),',',&
   &mesh1(i,7),',',&
   &mesh1(i,8)
end do
!---木材の要素の出力
print'("*ELEMENT, TYPE=C3D8, ELSET=Emoku")'
do i=1,nyou3+nyou4
   print'(i6,a,i6,a,i6,a,i6,a,i6,a,i6,a,i6,a,i6,a,i6)',&
   &nyou1+nyou2+i,',',&
   &mesh2(i,1),',',&
   &mesh2(i,2),',',&
   &mesh2(i,3),',',&
   &mesh2(i,4),',',&
   &mesh2(i,5),',',&
   &mesh2(i,6),',',&
   &mesh2(i,7),',',&
   &mesh2(i,8)
end do
!---鋼板のマスター面群
print'(A)',"*SURFACE,NAME=SMkou1"
do k=1,nz2-1!一要素分の隙間をあける
   !---鋼板上部
   do j=0,ny1-1
      l=nx2*(ny1*2+ny2)*(nz1+k)+nx2*j+nx2
      print'(i6,A)',l,',S2'
   enddo
   !---鋼板中部(上1/4)
   do j=0,int(ny2/4)-1
      l=nx2*(ny1*2+ny2)*(nz1+k)+nx2*(ny1+j)+nx2
      print'(i6,A)',l,',S2'
   enddo
enddo
print'(A)',"*SURFACE,NAME=SMkou2"
do k=1,nz2-1!一要素分の隙間をあける
   !---鋼板中部(下1/4)
   do j=ny2-int(ny2/4),ny2-1
      l=nx2*(ny1*2+ny2)*(nz1+k)+nx2*(ny1+j)+nx2
      print'(i6,A)',l,',S2'
   enddo
   !---鋼板下部
   do j=0,ny1-1
      l=nx2*(ny1*2+ny2)*(nz1+k)+nx2*(ny1+ny2+j)+nx2
      print'(i6,A)',l,',S2'
   enddo
enddo
!---木材のスレーブ面群
print'(A)',"*SURFACE,NAME=SSmoku1"
do k=1,nz2-1!一要素分の隙間をあける
  do j=0,ny1-1
     l=nyou1+nyou2+nyou3+(nx1*ny1*2)*k+nx1*j+1
     print'(i6,A)',l,',S1'
  enddo
enddo
print'(A)',"*SURFACE,NAME=SSmoku2"
do k=1,nz2-1!一要素分の隙間をあける
   do j=0,ny1-1
      l=nyou1+nyou2+nyou3+(nx1*ny1*2)*k+nx1*j+(nx1*ny1)+1
      print'(i6,A)',l,',S1'
   enddo
enddo
!---境界条件の節点群
print'("*NSET,NSET=koteiy")'!支持部
do i=1,nset
   if (y(i)>h1*2+h2-dy1/3.and.y(i)<h1*2+h2+dy1/3.and.&
       &z(i)>koteiy-dz1/2.and.z(i)<koteiy+dz1/2) then
      print'(i6,a)',i,','
   endif
end do
print'("*NSET,NSET=koteix")'!x軸対称面
do i=1,nset
   if (x(i)>b1+b2-dx1/3.and.x(i)<b1+b2+dy1/3) then
      print'(i6,a)',i,','
   endif
end do
print'("*NSET,NSET=koteiz")'!z軸対称面
do i=1,nset
   if (z(i)>ell-dz2/3.and.x(i)<ell+dz2/3) then
      print'(i6,a)',i,','
   endif
end do
!---荷重条件の節点群
print'("*NSET,NSET=saika1")'!直線上に載荷(中央の節点)
nsaika1=0
do i=nset1+1,nset1+nset2
   if (x(i)>b2+dx2/3.and.x(i)<b1+b2-dx1/3.and.&
       &y(i)>-dy1/3.and.y(i)<dy1/3.and.&
       &z(i)>ell-dz2/3.and.z(i)<ell+dz2/3) then
      nsaika1=nsaika1+1
      print'(i6,a)',i,','
   end if
end do
print'("*NSET,NSET=saika2")'!直線上に載荷(端の節点)
nsaika2=0
do i=nset1+1,nset1+nset2
   if (x(i)>b2-dx2/3.and.x(i)<b2+dx1/3.and.&
       &y(i)>-dy1/3.and.y(i)<dy1/3.and.&
       &z(i)>ell-dz2/3.and.z(i)<ell+dz2/3) then
      nsaika2=nsaika2+1
      print'(i6,a)',i,','
   elseif (x(i)>b1+b2-dx1/3.and.x(i)<b1+b2+dx1/3.and.&
       &y(i)>-dy1/3.and.y(i)<dy1/3.and.&
       &z(i)>ell-dz2/3.and.z(i)<ell+dz2/3) then
      nsaika2=nsaika2+1
      print'(i6,a)',i,','
   end if
end do
print'(A)',"*NSET,NSET=pre"!プレストレス1
npre=0
do j=0,int(np/2)
   do i=1,nset
      if (x(i)>-dx2/3.and.x(i)<dx2/3.and.&!上のプレストレス
          &y(i)>h1/2-anka/2-dy1/3.and.y(i)<h1/2+anka/2+dy1/3.and.&
          &z(i)>ell-sakaiz-ellp*j-anka/2-dz2/3.and.z(i)<ell-sakaiz-ellp*j+anka/2+dz2/3) then
         npre=npre+1
         print'(i6,a)',i,','
      end if
      if (x(i)>-dx2/3.and.x(i)<dx2/3.and.&!下のプレストレス
          &y(i)>h1+h2+h1/2-anka/2-dy1/3.and.y(i)<h1+h2+h1/2+anka/2+dy1/3.and.&
          &z(i)>ell-sakaiz-ellp*j-anka/2-dz2/3.and.z(i)<ell-sakaiz-ellp*j+anka/2+dz2/3) then
         npre=npre+1
         print'(i6,a)',i,','
      end if
   end do
enddo
!do i=1,nset
!   if (x(i)>-dx2/3.and.x(i)<dx2/3.and.&!上のプレストレス
!       &y(i)>h1/2-anka/2-dy1/3.and.y(i)<h1/2+anka/2+dy1/3.and.&
!       &z(i)>anka/2.and.z(i)<ell-sakaiz+anka/2) then
!      npre1=npre1+1
!      print'(i6,a)',i,','
!   end if
!   if (x(i)>-dx2/3.and.x(i)<dx2/3.and.&!下のプレストレス
!       &y(i)>h1+h2+h1/2-anka/2-dy1/3.and.y(i)<h1+h2+h1/2+anka/2+dy1/3.and.&
!       &z(i)>anka/2.and.z(i)<ell-sakaiz+anka/2) then
!      npre1=npre1+1
!      print'(i6,a)',i,','
!   end if
!end do
!print'(A)',"*NSET,NSET=pre2"!プレストレス2
!npre2=0
!do i=1,nset
!   if (x(i)>-dx2/3.and.x(i)<dx2/3.and.&!上のプレストレス
!       &y(i)>h1/2-anka/2-dy1/3.and.y(i)<h1/2+anka/2+dy1/3.and.&
!       &z(i)>ell-sakaiz+anka/2.and.z(i)<ell-anka/2) then
!      npre2=npre2+1
!      print'(i6,a)',i,','
!   end if
!   if (x(i)>-dx2/3.and.x(i)<dx2/3.and.&!下のプレストレス
!       &y(i)>h1+h2+h1/2-anka/2-dy1/3.and.y(i)<h1+h2+h1/2+anka/2+dy1/3.and.&
!       &z(i)>ell-sakaiz+anka/2.and.z(i)<ell-anka/2) then
!      npre2=npre2+1
!      print'(i6,a)',i,','
!   end if
!end do
print'("*NSET,NSET=jouen")'!梁中央の断面の上縁
do i=1,nset
   if (x(i)>-dx2/3.and.x(i)<b1+b2+dx1/3.and.&
       &y(i)>-dy1/3.and.y(i)<dy1/3.and.&
       &z(i)>ell-dz2/3.and.z(i)<ell+dz2/3) then
      print'(i6,a)',i,','
   end if
end do
print'("*NSET,NSET=kaen")'!梁中央の断面の下縁(木材のみ)
do i=nset1+1,nset1+nset2
   if (x(i)>b2-dx2/3.and.x(i)<b1+b2+dx1/3.and.&
       &y(i)>h1*2.d0+h2-dy1/3.and.y(i)<h1*2.d0+h2+dy1/3.and.&
       &z(i)>ell-dz2/3.and.z(i)<ell+dz2/3) then
      print'(i6,a)',i,','
   end if
end do
print'("*NSET,NSET=kou")'!鋼板の中央の断面
do i=1,nset1
   if (z(i)>ell-dz2/3.and.z(i)<ell+dz2/3) then
      print'(i6,a)',i,','
   end if
end do
!---境界条件
print'("*BOUNDARY")'
print'("koteiy,2")'
print'("koteix,1")'
print'("koteiz,3")'
!#--鋼板と木材の接触および摩擦の設定
do i=1,2
   print'(A,i1)',"*CONTACT PAIR,INTERACTION=SI",i
   print'(A,i1,A,i1)',"SSmoku",i,",SMkou",i!スレーブ面,マスター面
   print'(A,i1)',"*SURFACE INTERACTION,NAME=SI",i
   print'("*SURFACE BEHAVIOR,PRESSURE-OVERCLOSURE=EXPONENTIAL")'
   print'("1.e-4,1.e-0")'!接触と判定する距離(m),距離0の時の応力?
   print'("*FRICTION")'
   print'("0.4,1000")'!摩擦係数,謎パラメータ
enddo
!---木材の材料設定
print'("*MATERIAL,NAME=ELmoku")'
print'("*ELASTIC,TYPE=ORTHOROPIC")'
call ortho(e66,exx,eyy,ezz,poixy,poixz,poiyz,gyz,&
& gxz,gxy,poiyx,poizx,poizy)
print'(f12.4,a,f12.4,a,f12.4,a,&
&f12.4,a,f12.4,a,f12.4,a,f12.4,&
& a ,f12.4,a)',&
&e66(1,1),',',e66(1,2),',',e66(2,2),',',e66(1,3),','& 
&,e66(2,3),',',e66(3,3),',',e66(6,6),',',e66(5,5),','
print'(f12.4,a)',e66(4,4)
!---鋼材の材料設定
print'("*MATERIAL,NAME=ELkou")'
print'("*ELASTIC")'
print'(f12.4,a,f12.4)',ekou,',',poikou
print'("*SOLID SECTION,ELSET=Emoku,MATERIAL=ELmoku")'
print'("*SOLID SECTION,ELSET=Ekou,MATERIAL=ELkou")'
!---出力ステップ
print'("*TIME POINTS,NAME=T1")'
do i=0,nstep
   ts=real(i)/nstep
   print'(f12.4,a)',ts,','
enddo
!---プレストレス
print'("*STEP,NLGEOM")'
print'("*STATIC")'
print'("*CLOAD")'
print'(A,a,i6,a,1pe13.5)','pre',',',1,',',px*np/npre
print'("*NODE FILE")'
print'("U")'
print'("*EL FILE")'
print'("S")'
print'("*END STEP")'
!---載荷条件
print'("*STEP,NLGEOM,INC=10000")'
print'("*STATIC")'
print'("*CLOAD")'
print'(A,a,i6,a,1pe13.5)','saika1',',',2,',',py/(nsaika1+1)
print'(A,a,i6,a,1pe13.5)','saika2',',',2,',',py/2/(nsaika1+1)
!print'("*BUCKLE")'
!print'("5,0.01")'
!#--出力の設定
print'("*NODE PRINT,NSET=kou,TIMEPOINTS=T1")'!鋼板の中央の断面の変位
print'("U")'
!print'("*NODE PRINT,NSET=jouen,TIMEPOINTS=T1")'!梁中央上縁のたわみ
!print'("U")'
!print'("*NODE PRINT,NSET=kaen,TIMEPOINTS=T1")'!梁中央下縁のたわみ
!print'("U")'
!print'("*NODE PRINT,NSET=koteiz,TIMEPOINTS=T1")'!梁中央の断面のたわみ
!print'("U")'
print'("*NODE FILE")'
print'("U")'
print'("*EL FILE")'
print'("S")'
print'("*END STEP")'

end
!######## 直交異方性の定数を出すプログラム ########
subroutine ortho(e66,exx,eyy,ezz,poixy,poixz,poiyz,gyz,&
&gxz,gxy,poiyx,poizx,poizy)
implicit none
real :: e66(6,6),b(3,3)
real exx,eyy,ezz,poixy,poixz,poiyz,gyz,gxz,gxy,poiyx,poizx,poizy
real det
integer i,j
!implicit real*8(a-h,o-z)
!dimension e66(6,6),b(3,3)
!応力－ひずみ行列：e66
!do i=1,6
!do j=1,6
!e66(i,j)=0.d0
!end do
!end do
!  
e66=0.d0
e66(1,1)=1.d0/exx
e66(1,2)=-poixy/exx
e66(1,3)=-poixz/exx
e66(2,1)=-poiyx/eyy
e66(2,2)=1.d0/eyy
e66(2,3)=-poiyz/eyy
e66(3,1)=-poizx/ezz
e66(3,2)=-poizy/ezz
e66(3,3)=1.d0/ezz
!
!****** 逆行列を取って、応力－ひずみ行列に変換する******
det=e66(1,1)*e66(2,2)*e66(3,3)+e66(2,1)*e66(3,2)*e66(1,3)&
&+e66(3,1)*e66(1,2)*e66(2,3)-e66(2,1)*e66(1,2)*e66(3,3)&
&-e66(3,1)*e66(2,2)*e66(1,3)-e66(1,1)*e66(3,2)*e66(2,3)
b(1,1)=(-1.d0)**(1+1)*(e66(2,2)*e66(3,3)-e66(3,2)*e66(2,3))
b(1,2)=(-1.d0)**(1+2)*(e66(2,1)*e66(3,3)-e66(3,1)*e66(2,3))
b(1,3)=(-1.d0)**(1+3)*(e66(2,1)*e66(3,2)-e66(3,1)*e66(2,2))
b(2,1)=(-1.d0)**(2+1)*(e66(1,2)*e66(3,3)-e66(3,2)*e66(1,3))
b(2,2)=(-1.d0)**(2+2)*(e66(1,1)*e66(3,3)-e66(3,1)*e66(1,3))
b(2,3)=(-1.d0)**(2+3)*(e66(1,1)*e66(3,2)-e66(3,1)*e66(1,2))
b(3,1)=(-1.d0)**(3+1)*(e66(1,2)*e66(2,3)-e66(2,2)*e66(1,3))
b(3,2)=(-1.d0)**(3+2)*(e66(1,1)*e66(2,3)-e66(2,1)*e66(1,3))
b(3,3)=(-1.d0)**(3+3)*(e66(1,1)*e66(2,2)-e66(2,1)*e66(1,2))
do i=1,3
do j=1,3
e66(i,j)=b(j,i)/det
end do
end do
!
!****** せん断補正係数を入力 ******
!print*,'xy面のせん断弾性係数を入れて下さい'
!read*, gxy
e66(4,4)=gyz
!print*,'xz面のせん断弾性係数を入れて下さい'
!read*, gxz
e66(5,5)=gxz
!print*,'yz面のせん断弾性係数を入れて下さい'
!read*, gyz
e66(6,6)=gxy
!
!
return
end



